HDU1025_Constructing Roads In JGShining's Kingdom【LIS】【二分法】

Constructing Roads In JGShining‘s Kingdom

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 16590    Accepted Submission(s): 4722

Problem Description

JGShining‘s kingdom consists of 2n(n is no more than 500,000) small cities which are located in two parallel lines.

Half of these cities are rich in resource (we call them rich cities) while the others are short of resource (we call them poor cities). Each poor city is short of exactly one kind of resource and also each rich city is rich in exactly one kind of resource.
You may assume no two poor cities are short of one same kind of resource and no two rich cities are rich in one same kind of resource.

With the development of industry, poor cities wanna import resource from rich ones. The roads existed are so small that they‘re unable to ensure the heavy trucks, so new roads should be built. The poor cities strongly BS each other, so are the rich ones. Poor
cities don‘t wanna build a road with other poor ones, and rich ones also can‘t abide sharing an end of road with other rich ones. Because of economic benefit, any rich city will be willing to export resource to any poor one.

Rich citis marked from 1 to n are located in Line I and poor ones marked from 1 to n are located in Line II.

The location of Rich City 1 is on the left of all other cities, Rich City 2 is on the left of all other cities excluding Rich City 1, Rich City 3 is on the right of Rich City 1 and Rich City 2 but on the left of all other cities ... And so as the poor ones.

But as you know, two crossed roads may cause a lot of traffic accident so JGShining has established a law to forbid constructing crossed roads.

For example, the roads in Figure I are forbidden.

In order to build as many roads as possible, the young and handsome king of the kingdom - JGShining needs your help, please help him. ^_^

Input

Each test case will begin with a line containing an integer n(1 ≤ n ≤ 500,000). Then n lines follow. Each line contains two integers p and r which represents that Poor City p needs to import resources from Rich City r. Process to the end of file.

Output

For each test case, output the result in the form of sample.

You should tell JGShining what‘s the maximal number of road(s) can be built.

Sample Input

2

1 2

2 1

3

1 2

2 3

3 1

Sample Output

Case 1:

My king, at most 1 road can be built.

Case 2:

My king, at most 2 roads can be built.

Hint

Huge input, scanf is recommended.

Author

JGShining(极光炫影)

题目大意:路两旁各有N个城市,一旁N个富城市,一旁N个穷城市,每个穷

城市缺少一种资源(各不相同),每个富城市拥有一种资源(各不相同),穷城市

p需要从富城市r得到这种资源,就得修路。为了不造成交通堵塞,修的路不能

有交叉,问最多能修几条路,也就是有几个城市得到资源。

思路:就是给你两边各N个点,在这两边连线,每个点只能连一次,问最多有

多少线不交叉。把一边的点按升序排列,那么题目就转换为求另一边的最大上

升子序列了,而这道题数据规模为500000,O(N^2)算法肯定超时,只能用

栈+二分法的O(NlogN)的算法实现,具体参考博客:

http://blog.csdn.net/lianai911/article/details/20554865

这道题和POJ1631类似,也可以看看那道题的题解:

http://blog.csdn.net/lianai911/article/details/41442377

最后注意输出的时候1条路是1 road,多于一条是n roads

# include<stdio.h>
# include<string.h>
int arr[500010];
int lis[500010];

int list(int arr[],int n)
{
    int i,j,k,m,max;
    max = 0;
    for(i=n;i>=1;i--)
    {
        j = 1;
        k = max;
        while(j<=k)
        {
            m = (j+k)/2;
            if(lis[m]>arr[i])
                j = m + 1;
            else
                k = m - 1;
        }
        if(j > max)
            max++;
        lis[j] = arr[i];
    }
    return max;
}

int main()
{
    int n,i,t=1,a,b,max=0;
    while(~scanf("%d",&n))
    {
        memset(arr,0,sizeof(arr));
        memset(lis,0,sizeof(lis));
        for(i=1;i<=n;i++)
        {
            scanf("%d%d",&a,&b);
            arr[a] = b;
        }
        max = list(arr,n);
        printf("Case %d:\n",t++);
        if(max==1)
            printf("My king, at most 1 road can be built.\n\n");
        else
            printf("My king, at most %d roads can be built.\n\n",max);
    }

    return 0;
}

HDU1025_Constructing Roads In JGShining's Kingdom【LIS】【二分法】

时间: 2024-08-29 08:02:05

HDU1025_Constructing Roads In JGShining's Kingdom【LIS】【二分法】的相关文章

HDU 1025 Constructing Roads In JGShining&#39;s Kingdom LIS题解

本题是LIS题解.主要是理解他的题意.他的题意都好像比较隐晦,比如每个poor city和rich city一定是需要对应起来的,比如poor city和rich city并不是按顺序给出的. 其实是可以把数列按照poor city排序,然后求rich city城市号的最大递增子序列. 不过这里不用排序,利用hash的思想直接对应起来就可以了. 然后就是本题是卡DP的O(n*n)的解法的,这里需要O(nlgn)的LIS解法. 二分好已经找到的递增序列,插入新的数值就可以了.是利用了一个单调队列的

Constructing Roads In JGShining&#39;s Kingdom(HDU 1025 LIS nlogn方法)

Constructing Roads In JGShining's Kingdom Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 21002    Accepted Submission(s): 5935 Problem Description JGShining's kingdom consists of 2n(n is no mor

HDU1025——LIS——Constructing Roads In JGShining&#39;s Kingdom

Problem Description JGShining's kingdom consists of 2n(n is no more than 500,000) small cities which are located in two parallel lines. Half of these cities are rich in resource (we call them rich cities) while the others are short of resource (we ca

HDU 1025 Constructing Roads In JGShining&#39;s Kingdom   LIS 简单题 好题 超级坑

Constructing Roads In JGShining's Kingdom Problem Description JGShining's kingdom consists of 2n(n is no more than 500,000) small cities which are located in two parallel lines. Half of these cities are rich in resource (we call them rich cities) whi

LIS问题---HDU1025 Constructing Roads In JGShining&#39;s Kingdom

发现这个说的比较通俗: 假设存在一个序列d[1..9] = 2 1 5 3 6 4 8 9 7,可以看出来它的LIS长度为5.下面一步一步试着找出它.我们定义一个序列B,然后令 i = 1 to 9 逐个考察这个序列.此外,我们用一个变量Len来记录现在最长算到多少了首先,把d[1]有序地放到B里,令B[1] = 2,就是说当只有1一个数字2的时候,长度为1的LIS的最小末尾是2.这时Len=1然后,把d[2]有序地放到B里,令B[1] = 1,就是说长度为1的LIS的最小末尾是1,d[1]=2

HDU 1025:Constructing Roads In JGShining&#39;s Kingdom(LIS+二分优化)

http://acm.hdu.edu.cn/showproblem.php?pid=1025 Constructing Roads In JGShining's Kingdom Problem Description JGShining's kingdom consists of 2n(n is no more than 500,000) small cities which are located in two parallel lines.Half of these cities are r

hdu 1025 Constructing Roads In JGShining&#39;s Kingdom(二分法+最长上升子序列)

题目大意:河的两岸有两个不同的国家,一边是穷国,一边是富国,穷国和富国的村庄的标号是固定的,穷国要变富需要和富国进行交流,需要建桥,并且建的桥不能够有交叉.问最多可以建多少座桥.      思路:建路时如下图所示                 当一边的点已经固定了的时候,另外一边按照从小到大的序列与当前的边连接,得到最少的交叉.           题目给的第二组测试数据,如果按照图一则可以建2座桥,图二建一座桥 3 1 2 2 3 3 1                           

hdu1025 Constructing Roads In JGShining&#39;s Kingdom (nlogn的LIS)

题目链接 第一次写nlogn复杂度的LIS,纪念一下. 题目意思是说.有两条平行线,两条平行线都有n个城市,都是从左到右标记为1--n,一条线上是富有城市,一个是贫穷城市.输入n,接下来有n行,p,r表示穷城市p和富有城市r 之间可以建一条路(p的顺序是1--n,一个贫穷城市只对应一个富有城市(弱爆的语文描述能力T_T)),公路不能交叉. 问最多可以建多少条公路. 在别处看到的对nlogn解法的解释吧算是: 时间复杂度:(NlogN): 除了算法一的定义之外,增加一个数组b,b[i]用以表示长度

HDU 1025 Constructing Roads In JGShining&#39;s Kingdom(二维LIS)

Constructing Roads In JGShining's Kingdom Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 23467    Accepted Submission(s): 6710 Problem Description JGShining's kingdom consists of 2n(n is no mo